﻿using UnityEngine;
using System.Collections;

namespace RatKing {

	public class Portrait : MonoBehaviour {
		public Material mat;
		public Texture2D[] texes;
		public float[] waitMin = { 10f, 2f };
		public float[] waitMax = { 20f, 4f };

		IEnumerator Start() {
			mat = (Material)Instantiate(mat);
			GetComponent<Renderer>().material = mat; 
			int index = 0;
			for (; ; ) {
				mat.mainTexture = texes[index];
				yield return new WaitForSeconds(Random.Range(waitMin[index], waitMax[index]));
				index = (index + 1) % texes.Length;
			}
		}
	}

}