﻿using UnityEngine;
using System.Collections;
using DG.Tweening;

namespace RatKing {

	public class Punch : MonoBehaviour {
		public SphereCollider sphere;
		public float duration = 0.25f;
		public float speed = 8f;
		public float freezeTime = 2f;
		public float force = 20f;
		//
		Vector3 velocity = Vector3.zero;

		//

		void Update() {
			transform.Translate((transform.forward + velocity) * Time.deltaTime * speed, Space.World);
		}

		//

		public void Do(Rigidbody puncher, Player byPlayer) {
			var r = gameObject.GetComponentInChildren<Renderer>();
			var c = r.material.color;
			c.a = 0f;
			DOTween.To(() => r.material.color, val => r.material.color = val, c, duration).SetEase(Ease.InQuad).OnComplete(() => Destroy(gameObject));
			velocity = puncher.velocity * 0.2f;
			bool punched = false;
			bool punchedTeacher = false;
			for (var iter = Physics.OverlapSphere(sphere.transform.position, sphere.radius).GetEnumerator(); iter.MoveNext(); ) {
				var rb = ((Collider)iter.Current).attachedRigidbody;
				if (rb != null && rb != puncher) {
					var p = rb.GetComponent<Player>();
					if (p != null) {
						if (p.GetPunched(transform.forward * force, puncher.GetComponent<Player>(), freezeTime)) {
							punched = true;
						}
					}
					else if (rb.GetComponent<Teacher>() != null) {
						punchedTeacher = true;
						punched = true;
					}
				}
			}
			if (punched) {
				Main.inst.sndHitOuch.Play();
				Main.inst.PlayerDidBad(byPlayer, punchedTeacher ? 6 : 4);
			}
			else {
				Main.inst.sndHitFail.Play();
			}
		}
	}

}